package de.valentin.colorconsistency;

import android.app.IntentService;
import android.content.Intent;
import android.util.Log;
import androidx.annotation.Nullable;
import de.valentin.colorconsistency.ToGravityBox.GravitBoxConnector;
import de.valentin.colorconsistency.ToKWLP.KLWPConnector;
import de.valentin.colorconsistency.ToNova.NovaLauncherConnector;
import de.valentin.colorconsistency.ToSwiftkey.SwiftkeyConnector;
import de.valentin.colorconsistency.image.*;

import java.io.File;

public class ImageChangeService extends IntentService {

    /**
     * Creates an IntentService.  Invoked by your subclass's constructor.
     *
     * @param name Used to name the worker thread, important only for debugging.
     */
    public ImageChangeService(String name) {
        super(name);
    }
    public ImageChangeService() {
        super("ImageChangeService");
    }


    @Override
    protected void onHandleIntent(@Nullable Intent intent) {



       //  RedditImage redditImage=new RedditImage();
       // String imagePath= redditImage.getImageURL();

        String variant="earthview";

        switch(variant){
            case "local":{
                RandomImage randomImage = new RandomImage(new File("/storage/emulated/0/Pictures/Wallpapers"));
                applyChangedImage(randomImage);
            }
            break;
            case "earthview":{
                Earthview earthview=new Earthview(this);
            }
            break;
            case "reddit":{
                RedditImage redditImage=new RedditImage();
                applyChangedImage(redditImage);
            }
        }



    }


   public void applyChangedImage( SelectedImage image){
       Log.v("PATH",image.getPath());
      Log.v("PATH","d"+String.valueOf(image.getSelectedColors().getBackground()));



        SelectedColors colors = image.getSelectedColors();
      // SelectedColors colors = new SelectedColors(300,300,300);
        String imagePath = image.getPath();


        sendBroadcast(new KLWPConnector(imagePath, colors).getIntent());

        sendBroadcast(new GravitBoxConnector(colors).getIntent());

        SwiftkeyConnector swiftkeyConnector = new SwiftkeyConnector(colors.getForeground());
        swiftkeyConnector.writeFile();
        sendBroadcast(swiftkeyConnector.getIntent());

        new NovaLauncherConnector(colors).writeFile();

    }



}
