package de.valentin.colorconsistency.ToKWLP;

import android.content.Intent;
import de.valentin.colorconsistency.image.SelectedColors;

public class KLWPConnector {

    Intent intent;

    public static final String KUSTOM_ACTION = "org.kustom.action.SEND_VAR";
    public static final String KUSTOM_ACTION_EXT_NAME = "org.kustom.action.EXT_NAME";
    public static final String KUSTOM_ACTION_VAR_NAME = "org.kustom.action.VAR_NAME";
    public static final String KUSTOM_ACTION_VAR_VALUE = "org.kustom.action.VAR_VALUE";
    public static final String KUSTOM_ACTION_VAR_NAME_ARRAY = "org.kustom.action.VAR_NAME_ARRAY";
    public static final String KUSTOM_ACTION_VAR_VALUE_ARRAY = "org.kustom.action.VAR_VALUE_ARRAY";



    public KLWPConnector(String imagePath, SelectedColors selectedColors){
        intent = new Intent(KUSTOM_ACTION);
        intent.putExtra(KUSTOM_ACTION_EXT_NAME, "colorconsistency");

        intent.putExtra(KUSTOM_ACTION_VAR_NAME_ARRAY , new String[]{"imagepath","background","foreground"});
        intent.putExtra(KUSTOM_ACTION_VAR_VALUE_ARRAY, new String[]{
                imagePath,
                String.format("#%06X", (0xFFFFFF & selectedColors.getBackground())),
                String.format("#%06X", (0xFFFFFF & selectedColors.getForeground()))
        });
    }

    public Intent getIntent() {
        return intent;
    }
}
