package de.valentin.colorconsistency.ToNova;

import android.text.TextUtils;
import com.topjohnwu.superuser.Shell;
import com.topjohnwu.superuser.io.SuFileInputStream;
import com.topjohnwu.superuser.io.SuFileOutputStream;
import de.valentin.colorconsistency.image.SelectedColors;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class NovaLauncherConnector {
    SelectedColors selectedColors;
    String filePath="data/data/com.teslacoilsw.launcher/shared_prefs/com.teslacoilsw.launcher_preferences.xml";

    public NovaLauncherConnector(SelectedColors selectedColors) {
        this.selectedColors = selectedColors;
    }

    public boolean writeFile(){

            try (InputStream in = new SuFileInputStream(filePath)) {


                DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
                DocumentBuilder builder = factory.newDocumentBuilder();
                Document doc = builder.parse(in);


                XPath xPath = XPathFactory.newInstance().newXPath();

                //replaceValueprefs(String key, String newValue, XPath xPath, Document doc)
                replaceValueprefs("drawer_background_color",String.valueOf(selectedColors.getForeground()),xPath,doc);
                replaceValueprefs("appsearch_background",String.valueOf(selectedColors.getForeground()),xPath,doc);
                replaceValueprefs("drawer_label_color",String.valueOf(selectedColors.getBackground()),xPath,doc);
                replaceValueprefs("drawer_fastscroll_color",String.valueOf(selectedColors.getBackground()),xPath,doc);


               // replaceCSVprefs(String key, String newValue, int index, XPath xPath, Document doc)
                replaceCSVprefs("folder_window_config",String.valueOf(selectedColors.getForeground()),2,xPath,doc);
                replaceCSVprefs("folder_cellspecs","#"+Integer.toHexString(selectedColors.getBackground()),3,xPath,doc);
                replaceCSVprefs("folder_icon_config","#"+Integer.toHexString(selectedColors.getForeground()),3,xPath,doc);
                replaceCSVprefs("drawer_search_style","#"+Integer.toHexString(selectedColors.getBackground()),2,xPath,doc);
                replaceCSVprefs("drawer_cellspecs","#"+Integer.toHexString(selectedColors.getBackground()),3,xPath,doc);

                Transformer tf = TransformerFactory.newInstance().newTransformer();
                tf.setOutputProperty(OutputKeys.INDENT, "yes");
                tf.setOutputProperty(OutputKeys.METHOD, "xml");
                tf.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "4");

                DOMSource domSource = new DOMSource(doc);

                OutputStream out = new SuFileOutputStream(filePath);
                tf.transform(domSource,  new StreamResult(out));

                Shell.su("am force-stop com.teslacoilsw.launcher").exec();
            } catch (XPathExpressionException | SAXException | IOException | ParserConfigurationException | TransformerException e) {
                e.printStackTrace();
            }
        return true;
    }

    void replaceCSVprefs(String key, String newValue, int index, XPath xPath, Document doc) throws XPathExpressionException {
        Node node = (Node) xPath.compile("//string[@name='"+key+"']").evaluate(doc, XPathConstants.NODE);
        String[] textConent=node.getTextContent().split(":");
        textConent[index]=newValue;
        node.setTextContent(TextUtils.join(":",textConent));
    }


    void replaceValueprefs(String key, String newValue, XPath xPath, Document doc) throws XPathExpressionException{
        Node node = (Node) xPath.compile("//int[@name='"+key+"']/@value").evaluate(doc, XPathConstants.NODE);
        node.setNodeValue(newValue);
    }

}
