package de.valentin.colorconsistency.image;

import android.annotation.SuppressLint;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import com.topjohnwu.superuser.io.SuFileOutputStream;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URL;

public class DownloadBitmap extends AsyncTask<String, Bitmap,Bitmap> {
    SelectedImage selectedImage;
    File outputFile;
    public DownloadBitmap(SelectedImage selectedImage, File outputFile) {
        this.selectedImage=selectedImage;
        this.outputFile=outputFile;
    }

    @Override
    protected Bitmap doInBackground(String... urls) {
        try {
            return BitmapFactory.decodeStream(new URL(urls[0]).openStream());
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    @SuppressLint("WrongThread")
    protected void onPostExecute(Bitmap bitmap) {

       selectedImage.setBitmap(bitmap);
       selectedImage.createPalette();
       Earthview si=(Earthview)selectedImage;

        try (OutputStream out = new FileOutputStream(outputFile)) {
            bitmap.compress(Bitmap.CompressFormat.JPEG, 100, out);
        }
        catch (Exception e){
            e.printStackTrace();
        }



            si.getImageChangeService().applyChangedImage(selectedImage);
    }
}
