package de.valentin.colorconsistency.image;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Log;
import androidx.annotation.Nullable;
import androidx.palette.graphics.Palette;
import com.pddstudio.earthview.EarthView;
import com.pddstudio.earthview.EarthWallpaper;
import com.pddstudio.earthview.SingleEarthViewCallback;
import de.valentin.colorconsistency.ImageChangeService;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;

public class Earthview extends SelectedImage implements SingleEarthViewCallback {

    ImageChangeService imageChangeService;

    public ImageChangeService getImageChangeService() {
        return imageChangeService;
    }

    public Earthview(ImageChangeService imageChangeService) {
        this.imageChangeService=imageChangeService;
        EarthView.withGoogle().getRandomEarthWallpaper(this);


    }

    @Override
    public void onStartedLoading() {

    }

    @Override
    public void onFinishedLoading(@Nullable @org.jetbrains.annotations.Nullable EarthWallpaper earthWallpaper) {
        if(earthWallpaper != null) {
            Log.v("IDEARTH",earthWallpaper.getWallpaperId());
            selected=new File("sdcard/Pictures/Earthview/"+earthWallpaper.getWallpaperId()+".jpg");

            path = selected.getAbsolutePath();
            if (!selected.exists()) {
                //  bitmap = BitmapFactory.decodeStream(url.openStream());
                new DownloadBitmap(this,selected).execute(earthWallpaper.getWallPhotoUrl());
            }
            else {


                bitmap = BitmapFactory.decodeFile(path);
                createPalette();

                imageChangeService.applyChangedImage(this);
            }


        }
    }

    @Override
    public void onCancelledLoading() {

    }


}
