package de.valentin.colorconsistency.image;

import android.graphics.Bitmap;
import android.graphics.Color;
import androidx.palette.graphics.Palette;

import java.io.File;

public class SelectedImage {
    File folder;
    File selected;
    String path;
    Bitmap bitmap;
    Palette palette;
    SelectedColors selectedColors;


    public void setBitmap(Bitmap bitmap) {
        this.bitmap = bitmap;
    }

    void createPalette(){
        palette = Palette.from(bitmap).generate();
        palette.getDarkMutedColor(0);
        selectedColors = new SelectedColors(
                palette.getLightMutedColor(Color.WHITE),
                palette.getDarkMutedColor(Color.BLACK),
                palette.getDominantColor(Color.WHITE));
    }


    public File getSelected() {
        return selected;
    }

    public String getPath() {
        return path;
    }

    public Bitmap getBitmap() {
        return bitmap;
    }

    public Palette getPalette() {
        return palette;
    }

    public SelectedColors getSelectedColors() {
        return selectedColors;
    }
}
